function gm(el){return document.getElementById(el);}

var mw = parseInt(gm("mw").value); 
var mh = parseInt(gm("mh").value); 

function getChildElementsByClassName(parentElement, className)
{
	var i, childElements, pattern, result;
	result = new Array();
	pattern = new RegExp("\\b"+className+"\\b");
	childElements = parentElement.getElementsByTagName('*');
	for(i = 0; i < childElements.length; i++)
	{
		if(childElements[i].className.search(pattern) != -1)
		{
			result[result.length] = childElements[i];
		}
	}
	return result;
}

function aTab(activeTabIndex)
{
	var i, tabContainer, tabContents;
	tabContainer = document.getElementById('tab-container');
	tabContents = getChildElementsByClassName(tabContainer, 'tab-content');
	if(tabContents.length > 0)
	{
		for(i = 0; i < tabContents.length; i++)
		{
			tabContents[i].style.display = "none";
		}
		tabContents[activeTabIndex].style.display = "block";
   		tabList = document.getElementById('tab-container-list');
		tabs = getChildElementsByClassName(tabContainer, 'tab-item');
		if(tabs.length > 0)
		{
			for(i = 0; i < tabs.length; i++)
			{
				tabs[i].className = "tab-item";
			}
			tabs[activeTabIndex].className = "tab-item tab-active";
			tabs[activeTabIndex].blur();
		}
	}
}

function gm_radio() {
var radio_block = gm("radio_block");
var mr = gm("mr").value; 
if (mr == "world" || parseInt(mr) > 0) {
radio_block.innerHTML = '<label><input type="radio" name="ml" id="countries" value="countries" onchange="gm_rcheck()" checked />Countries</label>';
}
else {
if (mr == "US") {
radio_block.innerHTML = '<label><input type="radio" name="ml" id="countries" value="countries" onchange="gm_rcheck()" checked />Country</label><label><input type="radio" name="ml" id="provinces" value="provinces" onchange="gm_rcheck()" />States</label>';
}
else {
var noProvinces = ["AX","AS","AI","AW","BM","BQ","BV","IO","KY","CX","CC","CK","CW","FK","FO","GF","PF","TF","GI","GP","GU","GG","HM","VA","HK","IM","JE","KE","MO","MT","MQ","YT","MC","MS","NC","NU","NF","MP","PS","PN","PR","RE","BL","MF","PM","WS","SG","SX","GS","SJ","TW","TK","TC","UM","VG","VI","WF","EH"];
if (noProvinces.indexOf(mr) > -1)
radio_block.innerHTML = '<label><input type="radio" name="ml" id="countries" value="countries" onchange="gm_rcheck()" checked />Country</label>';
else
radio_block.innerHTML = '<label><input type="radio" name="ml" id="countries" value="countries" onchange="gm_rcheck()" checked />Country</label><label><input type="radio" name="ml" id="provinces" value="provinces" onchange="gm_rcheck()" />Provinces</label>';
}
}
}


function gm_add() {

var n_region = gm("n_region").value;
var n_title = gm("n_title").value;
var n_tooltip = gm("n_tooltip").value;
var n_color = gm("n_color").value;

gm("md_block").innerHTML += '<div class="added_rows">\
	<div class="row region"><span class="gm_span">'+n_region+'</span><input name="region[]" type="text" value="'+n_region+'" class="hidden" /></div>\
	<div class="row title"><span class="gm_span">'+n_title+'</span><input name="title[]" type="text" value="'+n_title+'" class="hidden" /></div>\
	<div class="row tooltip"><span class="gm_span">'+n_tooltip+'</span><textarea name="tooltip[]" type="text" class="hidden" />'+n_tooltip+'</textarea></div>\
	<div class="row color" style="background-color:'+n_color+'"><span class="gm_span">'+n_color+'</span><input name="color[]" type="text" value="'+n_color+'" class="color  {hash:true, adjust:false} hidden" /></div>\
	<div class="row add">\
		<span class="icon edit" title="Edit" onclick="gm_edit(this);"></span>\
		<span class="icon delete" title="Delete" onclick="gm_delete(this);"></span>\
		<span class="icon save hidden" title="Save" onclick="gm_update(this);"></span>\
		<span class="icon cancel hidden" title="Cancel" onclick="gm_cancel(this);"></span>\
	</div>\
</div>';

gm("n_region").value = gm("n_title").value = gm("n_tooltip").value = "";

gm_draw();

}


function gm_edit(e){

jQuery(e).parent().parent().removeClass("added_rows").addClass("added_rows_edit").find("span.gm_span").addClass("hidden").end().find(".row.color").css("background-color", "").end().find("input,textarea").removeClass("hidden").end().find(".icon.edit,.icon.delete").addClass("hidden").end().find(".icon.save,.icon.cancel").removeClass("hidden");

new jscolor.init();
}


function gm_update(e){

jQuery(e).parent().parent().find('input[type=text], textarea').each(function() {
jQuery(this).parent().find("span.gm_span").html(jQuery(this).val()).removeClass("hidden").end().end().addClass("hidden");
});

var color = jQuery(e).parent().parent().find("input.color").val();
jQuery(e).parent().parent().removeClass("added_rows_edit").addClass("added_rows").find(".row.color").css("background-color", ""+color+"");

jQuery(e).parent().find(".icon.save,.icon.cancel").addClass("hidden").end().find(".icon.edit,.icon.delete").removeClass("hidden");

gm_draw();

}



function gm_cancel(e){

jQuery(e).parent().parent().find('input[type=text], textarea').each(function() {

jQuery(this).val(jQuery(this).parent().find("span.gm_span").html()).addClass("hidden").parent().find("span.gm_span").removeClass("hidden");

});

var color = jQuery(e).parent().parent().find("input.color").val();
jQuery(e).parent().parent().removeClass("added_rows_edit").addClass("added_rows").find(".row.color").css("background-color", ""+color+"");
jQuery(e).parent().find(".icon.save,.icon.cancel").addClass("hidden").end().find(".icon.edit,.icon.delete").removeClass("hidden");

}


function gm_delete(e){
if (confirm('Sure to delete?')==true)
{
jQuery(e).parent().parent().remove();
gm_draw();
}
}



function gm_draw(e) {
var mb = gm("mb").value;  
var bs = gm("bs").value; 
var bc = gm("bc").value; 
var ic = gm("ic").value;

gm("visblock").style.border = bs + "px solid " + bc;

if (e == "dim") {
mw = gm("mw").value;
mh = gm("mh").value;
gm("visblock").style.width = mw+"px";
gm("visblock").style.height = mh+"px";
}

var tc = gm("tc").value;
var mr = gm("mr").value;
var ml = getRadio('ml');
var ms = gm("ms").value; 


var data = new google.visualization.DataTable();

data.addColumn("string", "Country");
data.addColumn("number", "Value");

data.addColumn({type:"string", role:"tooltip"});

var colors_array = [];

var regions = document.querySelectorAll("#md_block input[name='region[]']");
var titles = document.querySelectorAll("#md_block input[name='title[]']");
var tooltips = document.querySelectorAll("#md_block textarea[name='tooltip[]']");
var colors = document.querySelectorAll("#md_block input[name='color[]']");
var values = document.querySelectorAll("#md_block input[name='value[]']");

for (i = 0; i < regions.length; i++) {

data.addRows([[{v:regions[i].value,f:titles[i].value},i,tooltips[i].value]]);

var cur = regions[i].value;

var color_value = colors[i].value;
colors_array.push(color_value);

}

var maxvalue = 1 < regions.length ? regions.length - 1 : 0;

var options = {
backgroundColor: {fill:mb },
colorAxis:  {minValue: 0, maxValue: maxvalue,  colors: colors_array},
legend: 'none',
datalessRegionColor: ic,
displayMode: "markers", 
enableRegionInteractivity: "true",
resolution: ml,
sizeAxis: {minValue: 1, maxValue:1, minSize:ms, maxSize: ms},
tooltip: {textStyle:{color:tc}, trigger:"focus"},
region:mr,
keepAspectRatio: "true",
width:mw,
height:mh
};


var chart = new google.visualization.GeoChart(gm("visualization"));

chart.draw(data, options);

}


function escapeChars(text) {
  return text
	  .replace(/&/g,'&amp;')
	  .replace(/</g,'&lt;')
	  .replace(/>/g,'&gt;')
	  .replace(/"/g, '&quot;');
}

google.load('visualization', '1', {'packages': ['geochart']});

function getRadio(rName) {
    var radioButtons = document.getElementsByName(rName);
    for (var i = 0; i < radioButtons.length; i++) {
        if (radioButtons[i].checked) return radioButtons[i].value;
    }
    return '';
}


function gm_rcheck(e) {
if (e == "region") 
gm_radio();

gm_draw();
}


function gminit() {
if (gm("mr_value").value != "")
gm("mr").value = gm("mr_value").value;

gm_draw();
}


window.onload=gminit;